searchData={"items":[{"type":"module","title":"GSS","doc":"Bootstrap Google Spreadsheet application.","ref":"GSS.html"},{"type":"function","title":"GSS.config/2","doc":"Read config settings scoped for GSS.","ref":"GSS.html#config/2"},{"type":"function","title":"GSS.start/2","doc":"","ref":"GSS.html#start/2"},{"type":"module","title":"GSS.Client","doc":"Model of Client abstraction\nThis process is a Producer for this GenStage pipeline.","ref":"GSS.Client.html"},{"type":"function","title":"GSS.Client.config/2","doc":"Read config settings scoped for GSS client.","ref":"GSS.Client.html#config/2"},{"type":"function","title":"GSS.Client.dispatcher_hash/1","doc":"Divide request into to partitions :read and :write","ref":"GSS.Client.html#dispatcher_hash/1"},{"type":"type","title":"GSS.Client.event/0","doc":"","ref":"GSS.Client.html#t:event/0"},{"type":"function","title":"GSS.Client.handle_call/3","doc":"Adds an event to the queue","ref":"GSS.Client.html#handle_call/3"},{"type":"function","title":"GSS.Client.handle_demand/2","doc":"Gives events for the next stage to process when requested","ref":"GSS.Client.html#handle_demand/2"},{"type":"function","title":"GSS.Client.init/1","doc":"","ref":"GSS.Client.html#init/1"},{"type":"type","title":"GSS.Client.partition/0","doc":"","ref":"GSS.Client.html#t:partition/0"},{"type":"function","title":"GSS.Client.request/5","doc":"Issues an HTTP request with the given method to the given URL using Finch.\n\nThis function is usually used indirectly by helper functions such as `get/3`, `post/4`, `put/4`, etc.","ref":"GSS.Client.html#request/5"},{"type":"function","title":"Arguments - GSS.Client.request/5","doc":"- **`method`**: HTTP method as an atom (e.g., `:get`, `:head`, `:post`, `:put`, `:delete`, etc.).\n- **`url`**: Target URL as a binary string.\n- **`body`**: Request body, which can be a binary, char list, or iodata. Special forms include:\n  - `{:form, [{K, V}, ...]}` – to send a form URL-encoded payload.\n  - `{:file, \"/path/to/file\"}` – to send a file.\n  - `{:stream, enumerable}` – to lazily send a stream of binaries/char lists.\n- **`headers`**: HTTP headers as a list of two-element tuples (e.g., `[{\"Accept\", \"application/json\"}]`).\n- **`options`**: A keyword list of Finch options. Supported options include:\n  - **`:timeout`** – Timeout (in milliseconds) for establishing a connection (default is 8000).\n  - **`:recv_timeout`** – Timeout (in milliseconds) for receiving data (default is 5000).\n  - **`:proxy`** – A proxy for the request; either a URL or a `{host, port}` tuple.\n  - **`:proxy_auth`** – Proxy authentication credentials as `{user, password}`.\n  - **`:ssl`** – SSL options as supported by Erlang’s `ssl` module.\n  - **`:follow_redirect`** – Boolean to indicate if redirects should be followed.\n  - **`:max_redirect`** – Maximum number of redirects to follow.\n  - **`:params`** – Enumerable of two-item tuples to be appended to the URL as query string parameters.\n  - Any other Finch-supported options can also be provided.\n\nTimeout values can be specified as an integer or as `:infinity`.","ref":"GSS.Client.html#request/5-arguments"},{"type":"function","title":"Returns - GSS.Client.request/5","doc":"- On success, returns `{:ok, %Finch.Response{}}`.\n- On failure, returns `{:error, reason}` where `reason` is an exception.","ref":"GSS.Client.html#request/5-returns"},{"type":"function","title":"Examples - GSS.Client.request/5","doc":"request(:post, \"https://my.website.com\", \"{\"foo\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"GSS.Client.html#request/5-examples"},{"type":"function","title":"GSS.Client.request_async/5","doc":"Starts a task with request that must be awaited on.","ref":"GSS.Client.html#request_async/5"},{"type":"function","title":"GSS.Client.start_link/1","doc":"","ref":"GSS.Client.html#start_link/1"},{"type":"module","title":"GSS.Client.Limiter","doc":"Model of Limiter request subscribed to Client with partition :write or :read\n\nThis process is a ProducerConsumer for this GenStage pipeline.","ref":"GSS.Client.Limiter.html"},{"type":"function","title":"GSS.Client.Limiter.ask_and_schedule/1","doc":"Check to reach limit.\n\nIf limit not reached ask again after `:interval` timeout,\notherwise ask after `:max_interval` timeout.","ref":"GSS.Client.Limiter.html#ask_and_schedule/1"},{"type":"function","title":"GSS.Client.Limiter.handle_demand/2","doc":"Gives events for the next stage to process when requested","ref":"GSS.Client.Limiter.html#handle_demand/2"},{"type":"function","title":"GSS.Client.Limiter.handle_events/3","doc":"","ref":"GSS.Client.Limiter.html#handle_events/3"},{"type":"function","title":"GSS.Client.Limiter.handle_info/2","doc":"Ask new events if needed","ref":"GSS.Client.Limiter.html#handle_info/2"},{"type":"function","title":"GSS.Client.Limiter.handle_subscribe/4","doc":"","ref":"GSS.Client.Limiter.html#handle_subscribe/4"},{"type":"function","title":"GSS.Client.Limiter.init/1","doc":"","ref":"GSS.Client.Limiter.html#init/1"},{"type":"type","title":"GSS.Client.Limiter.options/0","doc":"","ref":"GSS.Client.Limiter.html#t:options/0"},{"type":"function","title":"GSS.Client.Limiter.start_link/1","doc":"Starts an limiter manager linked to the current process.\n\nIf the event manager is successfully created and initialized, the function\nreturns {:ok, pid}, where pid is the PID of the server. If a process with the\nspecified server name already exists, the function returns {:error,\n{:already_started, pid}} with the PID of that process.","ref":"GSS.Client.Limiter.html#start_link/1"},{"type":"function","title":"Options - GSS.Client.Limiter.start_link/1","doc":"* `:name` - used for name registration as described in the \"Name\nregistration\" section of the module documentation\n* `:interval` - ask new events from producer after `:interval` milliseconds.\n* `:max_demand` - count of maximum requests per `:maximum_interval`\n* `:max_interval` - maximum time that allowed in `:max_demand` requests\n* `:clients` - list of clients with partition options. For example `[{GSS.Client, partition: :read}}]`.","ref":"GSS.Client.Limiter.html#start_link/1-options"},{"type":"type","title":"GSS.Client.Limiter.state/0","doc":"","ref":"GSS.Client.Limiter.html#t:state/0"},{"type":"module","title":"GSS.Client.Request","doc":"Worker of Request subscribed to Limiter, call request to API and send an answer to Client.","ref":"GSS.Client.Request.html"},{"type":"function","title":"GSS.Client.Request.handle_events/3","doc":"","ref":"GSS.Client.Request.html#handle_events/3"},{"type":"function","title":"GSS.Client.Request.handle_subscribe/4","doc":"Set the subscription to manual to control when to ask for events","ref":"GSS.Client.Request.html#handle_subscribe/4"},{"type":"function","title":"GSS.Client.Request.init/1","doc":"","ref":"GSS.Client.Request.html#init/1"},{"type":"type","title":"GSS.Client.Request.options/0","doc":"","ref":"GSS.Client.Request.html#t:options/0"},{"type":"function","title":"GSS.Client.Request.start_link/1","doc":"Starts an request worker linked to the current process.\nTakes events from Limiter and send requests through Finch","ref":"GSS.Client.Request.html#start_link/1"},{"type":"function","title":"Options - GSS.Client.Request.start_link/1","doc":"* `:name` - used for name registration as described in the \"Name registration\" section of the module documentation. Default is `Elixir.GSS.Client.Request`\n* `:limiters` - list of limiters with max_demand options. For example `[{Elixir.GSS.Client.Limiter, max_demand: 1}]`.","ref":"GSS.Client.Request.html#start_link/1-options"},{"type":"type","title":"GSS.Client.Request.state/0","doc":"","ref":"GSS.Client.Request.html#t:state/0"},{"type":"module","title":"GSS.Client.RequestParams","doc":"","ref":"GSS.Client.RequestParams.html"},{"type":"type","title":"GSS.Client.RequestParams.t/0","doc":"","ref":"GSS.Client.RequestParams.html#t:t/0"},{"type":"module","title":"GSS.Client.Supervisor","doc":"Supervisor to keep track of initialized Client, Limiter and Request processes.","ref":"GSS.Client.Supervisor.html"},{"type":"function","title":"GSS.Client.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GSS.Client.Supervisor.html#child_spec/1"},{"type":"function","title":"GSS.Client.Supervisor.init/1","doc":"","ref":"GSS.Client.Supervisor.html#init/1"},{"type":"function","title":"GSS.Client.Supervisor.start_link/1","doc":"","ref":"GSS.Client.Supervisor.html#start_link/1"},{"type":"module","title":"GSS.Registry","doc":"Google spreadsheets core authorization.\nAutomatically updates access token after expiration.","ref":"GSS.Registry.html"},{"type":"function","title":"GSS.Registry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GSS.Registry.html#child_spec/1"},{"type":"function","title":"GSS.Registry.init/1","doc":"","ref":"GSS.Registry.html#init/1"},{"type":"function","title":"GSS.Registry.new_spreadsheet/3","doc":"Add or replace Google Spreadsheet in a registry.","ref":"GSS.Registry.html#new_spreadsheet/3"},{"type":"function","title":"GSS.Registry.spreadsheet_pid/2","doc":"Fetch Google Spreadsheet proccess by it's id in the registry.","ref":"GSS.Registry.html#spreadsheet_pid/2"},{"type":"function","title":"GSS.Registry.start_link/1","doc":"","ref":"GSS.Registry.html#start_link/1"},{"type":"type","title":"GSS.Registry.state/0","doc":"State of Google Cloud API :\n    %{\n        auth: %Goth.Token{\n            expires: 1453356568,\n            token: \"ya29.cALlJ4HHWRvMkYB-WsAR-CZnexE459yA7QPqKg3nei1y2T7-iqmbcgxb8XrTATNn_Blim\",\n            type: \"Bearer\"\n        }\n    }","ref":"GSS.Registry.html#t:state/0"},{"type":"function","title":"GSS.Registry.token/0","doc":"Get account authorization token.","ref":"GSS.Registry.html#token/0"},{"type":"module","title":"GSS.Spreadsheet","doc":"Model of Google Spreadsheet for external interaction.","ref":"GSS.Spreadsheet.html"},{"type":"function","title":"GSS.Spreadsheet.add_conditional_format/4","doc":"Add Conditional Formula using a boolean rule (as opposed to a gradient rule).\n\nRequired keys in `params`:\n- `formula`: A value the condition is based on. The value is parsed as if the user\n  typed into a cell. Formulas are supported (and must begin with an = or a '+').\n- `color_map`: Represents a color in the RGBA color space. Keys are `red`,\n  `green`, `blue`, and `alpha`, and each value is in the interval [0, 1].","ref":"GSS.Spreadsheet.html#add_conditional_format/4"},{"type":"function","title":"GSS.Spreadsheet.add_number_format/4","doc":"Add Number Format.\n\nRequired keys in `params`:\n- `type`: The number format of the cell (e.g., `DATE` or `TIME`).\n- `pattern`: Pattern string used for formatting (e.g., `yyyy-mm-dd`).","ref":"GSS.Spreadsheet.html#add_number_format/4"},{"type":"function","title":"GSS.Spreadsheet.append_row/4","doc":"Append row in a spreadsheet after an index.","ref":"GSS.Spreadsheet.html#append_row/4"},{"type":"function","title":"GSS.Spreadsheet.append_rows/4","doc":"Batch update to append multiple rows.","ref":"GSS.Spreadsheet.html#append_rows/4"},{"type":"function","title":"GSS.Spreadsheet.batch_update_query/4","doc":"","ref":"GSS.Spreadsheet.html#batch_update_query/4"},{"type":"function","title":"GSS.Spreadsheet.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GSS.Spreadsheet.html#child_spec/1"},{"type":"function","title":"GSS.Spreadsheet.clear_basic_filter/2","doc":"Clear Basic Filter.","ref":"GSS.Spreadsheet.html#clear_basic_filter/2"},{"type":"function","title":"GSS.Spreadsheet.clear_row/3","doc":"Clear row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#clear_row/3"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/2","doc":"Batched clear, which deletes more then one record.\nPass either an array of ranges, or start and end row indexes.","ref":"GSS.Spreadsheet.html#clear_rows/2"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/3","doc":"","ref":"GSS.Spreadsheet.html#clear_rows/3"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/4","doc":"","ref":"GSS.Spreadsheet.html#clear_rows/4"},{"type":"function","title":"GSS.Spreadsheet.col_number_to_letters/1","doc":"","ref":"GSS.Spreadsheet.html#col_number_to_letters/1"},{"type":"function","title":"GSS.Spreadsheet.fetch/2","doc":"Granular read by a custom range from a spreadsheet.","ref":"GSS.Spreadsheet.html#fetch/2"},{"type":"function","title":"GSS.Spreadsheet.filter_specs/1","doc":"","ref":"GSS.Spreadsheet.html#filter_specs/1"},{"type":"function","title":"GSS.Spreadsheet.freeze_header/3","doc":"Freeze Row or Column Header.\n\nRequired keys in `params`:\n- `dim`: Either `:row` or `:col` to set the dimension to freeze.\n- `n_freeze`: Set the number of rows or columns to freeze.","ref":"GSS.Spreadsheet.html#freeze_header/3"},{"type":"function","title":"GSS.Spreadsheet.get_sheet_id/1","doc":"Get sheet id associated with list_name in state.","ref":"GSS.Spreadsheet.html#get_sheet_id/1"},{"type":"type","title":"GSS.Spreadsheet.grid_range/0","doc":"","ref":"GSS.Spreadsheet.html#t:grid_range/0"},{"type":"function","title":"GSS.Spreadsheet.grid_range/2","doc":"Combine the sheet_id into the grid_range, and drop any values from the range that are nil.","ref":"GSS.Spreadsheet.html#grid_range/2"},{"type":"function","title":"GSS.Spreadsheet.id/1","doc":"Get spreadsheet internal id.","ref":"GSS.Spreadsheet.html#id/1"},{"type":"function","title":"GSS.Spreadsheet.properties/1","doc":"Get spreadsheet properties.","ref":"GSS.Spreadsheet.html#properties/1"},{"type":"function","title":"GSS.Spreadsheet.range/4","doc":"","ref":"GSS.Spreadsheet.html#range/4"},{"type":"function","title":"GSS.Spreadsheet.range/5","doc":"","ref":"GSS.Spreadsheet.html#range/5"},{"type":"function","title":"GSS.Spreadsheet.read_row/3","doc":"Read row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#read_row/3"},{"type":"function","title":"GSS.Spreadsheet.read_rows/2","doc":"Batched read, which returns more than one record.\nPass either an array of ranges (or rows), or start and end row indexes.\n\nBy default it returns `nils` for an empty rows,\nuse `pad_empty: true` and `column_to: integer` options to fill records\nwith an empty string values.","ref":"GSS.Spreadsheet.html#read_rows/2"},{"type":"function","title":"GSS.Spreadsheet.read_rows/3","doc":"","ref":"GSS.Spreadsheet.html#read_rows/3"},{"type":"function","title":"GSS.Spreadsheet.read_rows/4","doc":"","ref":"GSS.Spreadsheet.html#read_rows/4"},{"type":"function","title":"GSS.Spreadsheet.rows/2","doc":"Get total amount of rows in a spreadsheet.","ref":"GSS.Spreadsheet.html#rows/2"},{"type":"function","title":"GSS.Spreadsheet.set_basic_filter/4","doc":"Set Basic Filter.\n\nTwo options for `params`:\n- To not filter out any rows, pass an empty map.\n- To filter out rows based on a column value, add these\n  keys: `col_idx`, `condition_type`, `user_entered_value`.","ref":"GSS.Spreadsheet.html#set_basic_filter/4"},{"type":"function","title":"GSS.Spreadsheet.set_font/4","doc":"Set Font.\n\nRequired key in `params`: `font_family`.","ref":"GSS.Spreadsheet.html#set_font/4"},{"type":"function","title":"GSS.Spreadsheet.sheets/2","doc":"Get spreadsheet sheets from properties.","ref":"GSS.Spreadsheet.html#sheets/2"},{"type":"type","title":"GSS.Spreadsheet.spreadsheet_data/0","doc":"","ref":"GSS.Spreadsheet.html#t:spreadsheet_data/0"},{"type":"type","title":"GSS.Spreadsheet.spreadsheet_response/0","doc":"","ref":"GSS.Spreadsheet.html#t:spreadsheet_response/0"},{"type":"function","title":"GSS.Spreadsheet.start_link/2","doc":"","ref":"GSS.Spreadsheet.html#start_link/2"},{"type":"type","title":"GSS.Spreadsheet.state/0","doc":"State of currently active Google spreadsheet:\n    %{\n        spreadsheet_id => \"16Wgt0fuoYDgEAtGtYKF4jdjAhZez0q77UhkKdeKI6B4\",\n        list_name => nil,\n        sheet_id => nil\n    }","ref":"GSS.Spreadsheet.html#t:state/0"},{"type":"function","title":"GSS.Spreadsheet.update_border/4","doc":"Update Border.\n\nMap `params` can only have keys in `[:top, :bottom, :left, :right]`. If a key is omitted,\nthen the border remains as-is on that side. Subkeys: `style`, `red`, `green`, `blue`, `alpha`.","ref":"GSS.Spreadsheet.html#update_border/4"},{"type":"function","title":"GSS.Spreadsheet.update_col_width/3","doc":"Update Column Width.\n\nRequired keys in `params`:\n- `col_idx`: Index of column.\n- `col_width`: Column width in pixels.","ref":"GSS.Spreadsheet.html#update_col_width/3"},{"type":"function","title":"GSS.Spreadsheet.update_col_wrap/4","doc":"Update Column Wrap.\n\nRequired keys in `params`:\n- `wrap_strategy`: How to wrap text in a cell. Options: [`overflow_cell`, `clip`, `wrap`].","ref":"GSS.Spreadsheet.html#update_col_wrap/4"},{"type":"function","title":"GSS.Spreadsheet.update_sheet_size/4","doc":"","ref":"GSS.Spreadsheet.html#update_sheet_size/4"},{"type":"function","title":"GSS.Spreadsheet.write_row/4","doc":"Override row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#write_row/4"},{"type":"function","title":"GSS.Spreadsheet.write_rows/4","doc":"Batch update to write multiple rows.\n\nRange schema should define the same amount of rows as\namound of records in data and same amount of columns\nas entries in data record.","ref":"GSS.Spreadsheet.html#write_rows/4"},{"type":"module","title":"GSS.Spreadsheet.Supervisor","doc":"Supervisor to keep track of initialized spreadsheet processes.","ref":"GSS.Spreadsheet.Supervisor.html"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GSS.Spreadsheet.Supervisor.html#child_spec/1"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.init/1","doc":"","ref":"GSS.Spreadsheet.Supervisor.html#init/1"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.spreadsheet/2","doc":"","ref":"GSS.Spreadsheet.Supervisor.html#spreadsheet/2"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.start_link/1","doc":"","ref":"GSS.Spreadsheet.Supervisor.html#start_link/1"},{"type":"exception","title":"GSS.GoogleApiError","doc":"Raised in case non 200 response code from Google Cloud API.","ref":"GSS.GoogleApiError.html"},{"type":"exception","title":"GSS.InvalidColumnIndex","doc":"Raised in case more than 255 columns is queried.","ref":"GSS.InvalidColumnIndex.html"},{"type":"exception","title":"GSS.InvalidInput","doc":"Raised in case invalid input params are passed","ref":"GSS.InvalidInput.html"},{"type":"exception","title":"GSS.InvalidRange","doc":"Raised in case invalid range is defined.","ref":"GSS.InvalidRange.html"},{"type":"extras","title":"Elixir Google Spreadsheets","doc":"# Elixir Google Spreadsheets\nElixir library to read and write data of Google Spreadsheets.\n\nThis library is based on __Google Cloud API v4__ and uses __Google Service Accounts__ to manage it's content.","ref":"readme.html"},{"type":"extras","title":"Integration with Ecto - Elixir Google Spreadsheets","doc":"Check [ecto_gss](https://github.com/Voronchuk/ecto_gss) if you need to integrate your Google Spreadsheet with Ecto changesets for validation and other features.\n\n# Setup\n1. Use [this](https://console.developers.google.com/start/api?id=sheets.googleapis.com) wizard to create or select a project in the Google Developers Console and automatically turn on the API. Click __Continue__, then __Go to credentials__.\n2. On the __Add credentials to your project page__, create __Service account key__.\n3. Select your project name as service account and __JSON__ as key format, download the created key and rename it to __service_account.json__.\n4. Press __Manage service accounts__ on a credential page, copy your __Service Account Identifier__: _[projectname]@[domain].iam.gserviceaccount.com_\n5. Create or open existing __Google Spreadsheet document__ on your __Google Drive__ and add __Service Account Identifier__ as user invited in spreadsheet's __Collaboration Settings__.\n6. Add `{:elixir_google_spreadsheets, \"~> 0.4\"}` to __mix.exs__ under `deps` function, add `:elixir_google_spreadsheets` in your application list.\n7. Add __service_account.json__ in your `config.exs` or other config file, like `dev.exs` or `prod.secret.exs`.\n    config :elixir_google_spreadsheets,\n        json: \"./config/service_account.json\" |> File.read!\n8. Run `mix deps.get && mix deps.compile`.","ref":"readme.html#integration-with-ecto"},{"type":"extras","title":"Testing - Elixir Google Spreadsheets","doc":"The [following Google Spreadsheet](https://docs.google.com/spreadsheets/d/1h85keViqbRzgTN245gEw5s9roxpaUtT7i-mNXQtT8qQ/edit?usp=sharing) is used to run tests locally, it can be copied to run local tests.","ref":"readme.html#testing"},{"type":"extras","title":"API limits - Elixir Google Spreadsheets","doc":"All Google API limits, suggested params are the following:\n\n```elixir\nconfig :elixir_google_spreadsheets, :client,\n  request_workers: 50,\n  max_demand: 100,\n  max_interval: :timer.minutes(1),\n  interval: 100,\n  result_timeout: :timer.minutes(10),\n  request_opts: [] # See Finch request options\n```\n\n# Usage\nInitialise spreadsheet thread with it's id which you can fetch from URL:\n\n```elixir\n    {:ok, pid} = GSS.Spreadsheet.Supervisor.spreadsheet(\"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX-XXXXXXXXX\")\n```\n\nOr if you wish to edit only a specific list:\n\n```elixir\n    {:ok, pid} = GSS.Spreadsheet.Supervisor.spreadsheet(\n        \"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX-XXXXXXXXX\",\n        list_name: \"my_list3\"\n    )\n```\n\nSample operations:\n\n* `GSS.Spreadsheet.id(pid)`\n* `GSS.Spreadsheet.properties(pid)`\n* `GSS.Spreadsheet.get_sheet_id(pid)`\n* `GSS.Spreadsheet.sheets(pid)`\n* `GSS.Spreadsheet.rows(pid)`\n* `GSS.Spreadsheet.update_sheet_size(pid, 10, 5)`\n* `GSS.Spreadsheet.read_row(pid, 1, column_to: 5)`\n* `GSS.Spreadsheet.read_rows(pid, 1, 10, column_to: 5, pad_empty: true)`\n* `GSS.Spreadsheet.read_rows(pid, [1, 3, 5], column_to: 5, pad_empty: true)`\n* `GSS.Spreadsheet.read_rows(pid, [\"A1:E1\", \"A2:E2\"])`\n* `GSS.Spreadsheet.write_row(pid, 1, [\"1\", \"2\", \"3\", \"4\", \"5\"])`\n* `GSS.Spreadsheet.write_rows(pid, [\"A2:E2\", \"A3:F3\"], [[\"1\", \"2\", \"3\", \"4\", \"5\"], [\"1\", \"2\", \"3\", \"4\", \"5\", \"6\"]])`\n* `GSS.Spreadsheet.append_row(pid, 1, [\"1\", \"2\", \"3\", \"4\", \"5\"])`\n* `GSS.Spreadsheet.append_rows(pid, 1, [[\"1\", \"2\", \"3\", \"4\", \"5\"], [\"1\", \"2\", \"3\", \"4\", \"5\", \"6\"]])`\n* `GSS.Spreadsheet.clear_row(pid, 1)`\n* `GSS.Spreadsheet.clear_rows(pid, 1, 10)`\n* `GSS.Spreadsheet.clear_rows(pid, [\"A1:E1\", \"A2:E2\"])`\n* `GSS.Spreadsheet.set_basic_filter(pid, %{row_from: 0, row_to: 5, col_from: 1, col_to: 10}, %{col_idx: 2, condition_type: \"TEXT_CONTAINS\", user_entered_value: \"test\"})`\n* `GSS.Spreadsheet.set_basic_filter(pid, %{row_from: nil, row_to: nil, col_from: nil, col_to: nil}, %{})`\n* `GSS.Spreadsheet.clear_basic_filter(pid)`\n* `GSS.Spreadsheet.freeze_header(pid, %{dim: :row, n_freeze: 1})`\n* `GSS.Spreadsheet.freeze_header(pid, %{dim: :col, n_freeze: 2})`\n* `GSS.Spreadsheet.update_col_width(pid, %{col_idx: 1, col_width: 200})`\n* `GSS.Spreadsheet.add_number_format(pid, %{row_from: 0, row_to: nil, col_from: 3, col_to: 4}, %{type: \"NUMBER\", pattern: \"#0.0%\"})`\n* `GSS.Spreadsheet.update_col_wrap(pid, %{row_from: 0, row_to: nil, col_from: 5, col_to: 7}, %{wrap_strategy: \"clip\"})`\n* `GSS.Spreadsheet.set_font(pid, %{row_from: nil, row_to: nil, col_from: nil, col_to: nil}, %{font_family: \"Source Code Pro\"})`\n* `GSS.Spreadsheet.add_conditional_format(pid, %{row_from: nil, row_to: nil, col_from: nil, col_to: nil}, %{formula: \"=$E1=\\\"TEST\\\"\", color_map: %{red: 1, green: 0.8, blue: 0.8}})`\n* `GSS.Spreadsheet.update_border(pid, %{row_from: 0, row_to: 10, col_from: 2, col_to: 5}, %{top: %{red: 1, style: \"dashed\"}, bottom: %{green: 1, blue: 0.7}, left: %{blue: 0.8, alpha: 0.75}})`\n\nLast function param of `GSS.Spreadsheet` function calls support the same `Keyword` options (in snake_case instead of camelCase), as defined in [Google API Docs](https://developers.google.com/sheets/reference/rest/v4/spreadsheets.values).\n\nWe also define `column_from` and `column_to` Keyword options which control range of cell which will be queried.\n\nDefault values:\n* `column_from = 1` - default is configurable as `:default_column_from`\n* `column_to = 26` - default is configurable as `:default_column_to`\n* `major_dimension = \"ROWS\"`\n* `value_render_option = \"FORMATTED_VALUE\"`\n* `datetime_render_option = \"FORMATTED_STRING\"`\n* `value_render_option = \"USER_ENTERED\"`\n* `insert_data_option = \"INSERT_ROWS\"`\n\n# Suggestions\n* Recommended columns __26__ (more on your own risk), max rows in a batch __100-300__ depending on your data size per row, configurable as `:max_rows_per_request`;\n* __Pull requests / reports / feedback are welcome.__","ref":"readme.html#api-limits"}],"proglang":"elixir","producer":{"name":"ex_doc","version":"0.37.2"},"content_type":"text/markdown"}